Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 850)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 851)
@@ -237,4 +237,5 @@
 /*
  * Notify application on call being transfered.
+ * !modified @061206
  */
 static void cb_on_call_transfer_request(pjsua_call_id call_id,
@@ -242,7 +243,9 @@
 				        pjsip_status_code *code)
 {
+    PyObject * ret;
+    int cd;
     if (PyCallable_Check(obj_callback->on_call_transfer_request))
     {
-        PyObject_CallFunctionObjArgs(
+        ret = PyObject_CallFunctionObjArgs(
             obj_callback->on_call_transfer_request,
 	    Py_BuildValue("i",call_id),
@@ -251,4 +254,11 @@
 	    NULL
         );
+	if (ret != NULL) {
+	    if (ret != Py_None) {
+		if (PyArg_Parse(ret,"i",&cd)) {
+		    *code = cd;
+		}
+	    }
+	}
     }
 }
@@ -260,4 +270,5 @@
  * call transfer request, for example to decide whether to 
  * terminate existing call.
+ * !modified @061206
  */
 static void cb_on_call_transfer_status( pjsua_call_id call_id,
@@ -267,7 +278,9 @@
 					pj_bool_t *p_cont)
 {
+    PyObject * ret;
+    int cnt;
     if (PyCallable_Check(obj_callback->on_call_transfer_status))
     {
-        PyObject_CallFunctionObjArgs(
+        ret = PyObject_CallFunctionObjArgs(
             obj_callback->on_call_transfer_status,
 	    Py_BuildValue("i",call_id),
@@ -278,4 +291,11 @@
 	    NULL
         );
+	if (ret != NULL) {
+	    if (ret != Py_None) {
+		if (PyArg_Parse(ret,"i",&cnt)) {
+		    *p_cont = cnt;
+		}
+	    }
+	}
     }
 }
@@ -285,4 +305,5 @@
  * Notify application about incoming INVITE with Replaces header.
  * Application may reject the request by setting non-2xx code.
+ * !modified @061206
  */
 static void cb_on_call_replace_request( pjsua_call_id call_id,
@@ -291,12 +312,15 @@
 					pj_str_t *st_text)
 {
+    PyObject * ret;
+    PyObject * txt;
+    int cd;
     if (PyCallable_Check(obj_callback->on_call_replace_request))
     {
-	pjsip_rx_data_Object * obj = (pjsip_rx_data_Object *)
+        pjsip_rx_data_Object * obj = (pjsip_rx_data_Object *)
 				      PyType_GenericNew(&pjsip_rx_data_Type,
 							NULL, NULL);
-	obj->rdata = rdata;
-
-        PyObject_CallFunctionObjArgs(
+        obj->rdata = rdata;
+
+        ret = PyObject_CallFunctionObjArgs(
             obj_callback->on_call_replace_request,
 	    Py_BuildValue("i",call_id),
@@ -306,4 +330,13 @@
 	    NULL
         );
+	if (ret != NULL) {
+	    if (ret != Py_None) {
+		if (PyArg_ParseTuple(ret,"iO",&cd, &txt)) {
+		    *st_code = cd;
+		    st_text->ptr = PyString_AsString(txt);
+		    st_text->slen = strlen(PyString_AsString(txt));
+		}
+	    }
+	}
     }
 }
@@ -1111,4 +1144,5 @@
  * msg_data_Object
  * typewrapper for MessageData class
+ * !modified @ 061206
  */
 typedef struct
@@ -1116,5 +1150,6 @@
     PyObject_HEAD
     /* Type-specific fields go here. */
-    pjsip_hdr hdr_list;
+    /*pjsip_hdr hdr_list;*/
+    PyObject * hdr_list;
     PyObject * content_type;
     PyObject * msg_body;
@@ -1125,7 +1160,9 @@
  * msg_data_dealloc
  * deletes a msg_data
+ * !modified @ 061206
  */
 static void msg_data_dealloc(msg_data_Object* self)
 {
+    Py_XDECREF(self->hdr_list);
     Py_XDECREF(self->content_type);
     Py_XDECREF(self->msg_body);
@@ -1137,4 +1174,5 @@
  * msg_data_new
  * constructor for msg_data object
+ * !modified @ 061206
  */
 static PyObject * msg_data_new(PyTypeObject *type, PyObject *args,
@@ -1146,4 +1184,11 @@
     if (self != NULL)
     {
+        Py_INCREF(Py_None);
+        self->hdr_list = Py_None;
+        if (self->hdr_list == NULL)
+    	{
+            Py_DECREF(self);
+            return NULL;
+        }
         self->content_type = PyString_FromString("");
         if (self->content_type == NULL)
@@ -1166,9 +1211,14 @@
 /*
  * msg_data_members
+ * !modified @ 061206
  */
 static PyMemberDef msg_data_members[] =
 {
     {
-    	"content_type", T_OBJECT_EX, offsetof(msg_data_Object, content_type),
+        "hdr_list", T_OBJECT_EX, offsetof(msg_data_Object, hdr_list),
+	0, "Additional message headers as linked list."
+    }, 
+    {
+	"content_type", T_OBJECT_EX, offsetof(msg_data_Object, content_type),
     	0, "MIME type of optional message body."
     },
@@ -1228,4 +1278,74 @@
 };
 
+/* 
+ * translate_hdr
+ * internal function 
+ * translate from hdr_list to pjsip_generic_string_hdr
+ */
+void translate_hdr(pj_pool_t *pool, pjsip_hdr *hdr, PyObject *py_hdr_list)
+{
+    int i;
+
+    if (PyList_Check(py_hdr_list)) {
+        pj_list_init(hdr);
+
+        for (i = 0; i < PyList_Size(py_hdr_list); i++) { 
+            pj_str_t hname, hvalue;
+	    pjsip_generic_string_hdr * new_hdr;
+            PyObject * tuple = PyList_GetItem(py_hdr_list, i);
+
+            if (PyTuple_Check(tuple)) {
+                hname.ptr = PyString_AsString(PyTuple_GetItem(tuple,0));
+                hname.slen = strlen(PyString_AsString(PyTuple_GetItem(tuple,0)));
+                hvalue.ptr = PyString_AsString(PyTuple_GetItem(tuple,1));
+                hvalue.slen = strlen(PyString_AsString(PyTuple_GetItem(tuple,1)));
+            } else {
+		hname.ptr = "";
+		hname.slen = 0;
+		hvalue.ptr = "";
+		hvalue.slen = 0;
+            }  
+            new_hdr = pjsip_generic_string_hdr_create(pool, &hname, &hvalue);
+            pj_list_push_back((pj_list_type *)hdr, (pj_list_type *)new_hdr);
+	}     
+    }
+}
+
+/* 
+ * translate_hdr_rev
+ * internal function
+ * translate from pjsip_generic_string_hdr to hdr_list
+ */
+
+void translate_hdr_rev(pjsip_generic_string_hdr *hdr, PyObject *py_hdr_list)
+{
+    int i;
+    int len;
+    pjsip_generic_string_hdr * p_hdr;
+
+    len = pj_list_size(hdr);
+    
+    if (len > 0) {
+	p_hdr = hdr;
+        Py_XDECREF(py_hdr_list);
+        py_hdr_list = PyList_New(len);
+
+	for (i = 0; i < len && p_hdr != NULL; i++) {
+	    PyObject * tuple;
+	    PyObject * str;
+
+	    tuple = PyTuple_New(2);
+	    
+	    str = PyString_FromStringAndSize(p_hdr->name.ptr, p_hdr->name.slen);
+	    PyTuple_SetItem(tuple, 0, str);
+	    str = PyString_FromStringAndSize(hdr->hvalue.ptr, p_hdr->hvalue.slen);
+	    PyTuple_SetItem(tuple, 1, str);
+	    PyList_SetItem(py_hdr_list, i, tuple);
+	    p_hdr = p_hdr->next;
+	}
+    }
+    
+    
+}
 
 /*
@@ -1444,5 +1564,5 @@
             return NULL;
         }
-         self->scheme = PyString_FromString("");
+        self->scheme = PyString_FromString("");
         if (self->scheme == NULL)
     	{
@@ -1450,5 +1570,5 @@
             return NULL;
         }
-		 self->username = PyString_FromString("");
+        self->username = PyString_FromString("");
         if (self->username == NULL)
     	{
@@ -1456,5 +1576,5 @@
             return NULL;
         }
-		 self->data = PyString_FromString("");
+        self->data = PyString_FromString("");
         if (self->data == NULL)
     	{
@@ -1473,27 +1593,27 @@
 static PyMemberDef pjsip_cred_info_members[] =
 {
-	{
-    	"realm", T_OBJECT_EX,
-    	offsetof(pjsip_cred_info_Object, realm), 0,
-    	"Realm"
-    },
-	{
-    	"scheme", T_OBJECT_EX,
-    	offsetof(pjsip_cred_info_Object, scheme), 0,
-    	"Scheme"
-    },
-	{
-    	"username", T_OBJECT_EX,
-    	offsetof(pjsip_cred_info_Object, username), 0,
-    	"User name"
-    },
-	{
-    	"data", T_OBJECT_EX,
-    	offsetof(pjsip_cred_info_Object, data), 0,
-    	"The data, which can be a plaintext password or a hashed digest. "
-    },
-    {
-    	"data_type", T_INT, offsetof(pjsip_cred_info_Object, data_type), 0,
-    	"Type of data"
+    {
+        "realm", T_OBJECT_EX,
+        offsetof(pjsip_cred_info_Object, realm), 0,
+        "Realm"
+    },
+    {
+        "scheme", T_OBJECT_EX,
+        offsetof(pjsip_cred_info_Object, scheme), 0,
+        "Scheme"
+    },
+    {
+        "username", T_OBJECT_EX,
+        offsetof(pjsip_cred_info_Object, username), 0,
+        "User name"
+    },
+    {
+        "data", T_OBJECT_EX,
+        offsetof(pjsip_cred_info_Object, data), 0,
+        "The data, which can be a plaintext password or a hashed digest. "
+    },
+    {
+        "data_type", T_INT, offsetof(pjsip_cred_info_Object, data_type), 0,
+        "Type of data"
     },
     
@@ -1548,42 +1668,65 @@
 };
 
+/*
+ * py_pjsua_thread_register
+ * !added @ 061206
+ */
+static PyObject *py_pjsua_thread_register(PyObject *pSelf, PyObject 
+*pArgs)
+{
+	
+    pj_status_t status;	
+    const char *name;
+    PyObject *py_desc;
+    pj_thread_t *thread;
+    void *thread_desc;
+    int size;
+    int i;
+    int *td;
+
+    if (!PyArg_ParseTuple(pArgs, "sO", &name, &py_desc))
+    {
+         return NULL;
+    }
+#if 0
+    size = PyList_Size(py_desc);
+    td = (int *)malloc(size * sizeof(int));
+    for (i = 0; i < size; i++) {
+	if (!PyArg_Parse(PyList_GetItem(py_desc,i),"i", td[i])) {
+	    return NULL;
+	}
+    }
+    thread_desc = td;
+#else
+    thread_desc = malloc(sizeof(pj_thread_desc));
+#endif
+    status = pj_thread_register(name, thread_desc, &thread);
+    return Py_BuildValue("i",status);
+}
 
 /*
  * py_pjsua_logging_config_default
+ * !modified @ 051206
  */
 static PyObject *py_pjsua_logging_config_default(PyObject *pSelf,
                                                     PyObject *pArgs)
 {
-    logging_config_Object *obj;
+    logging_config_Object *obj;	
     pjsua_logging_config cfg;
 
-    if (!PyArg_ParseTuple(pArgs, "O", &obj))
-    {
-        return NULL;
-    }
-    /*pj_bzero(cfg, sizeof(*cfg));
-
-    cfg->msg_logging = obj->msg_logging;
-    cfg->level = obj->level;
-    cfg->console_level = obj->console_level;
-    cfg->decor = obj->decor;*/
+    if (!PyArg_ParseTuple(pArgs, ""))
+    {
+        return NULL;
+    }
+    
     pjsua_logging_config_default(&cfg);
+	obj = (logging_config_Object *) logging_config_new
+		(&logging_config_Type,NULL,NULL);
     obj->msg_logging = cfg.msg_logging;
     obj->level = cfg.level;
     obj->console_level = cfg.console_level;
     obj->decor = cfg.decor;
-    /*printf("msg logging : %d\n",obj->msg_logging);
-    printf("level : %d\n",obj->level);
-    printf("console level : %d\n",obj->console_level);
-    printf("decor : %d\n",obj->decor);
-    printf("str sebelum ");
-    printf(PyString_AsString(obj->log_filename));
-
-    Py_XDECREF(obj->log_filename);
-    obj->log_filename = PyString_FromString("oke");
-    printf("\nstr sesudah ");
-    printf(PyString_AsString(obj->log_filename));*/
-    Py_INCREF(Py_None);
-    return Py_None;
+    
+    return (PyObject *)obj;
 }
 
@@ -1591,4 +1734,5 @@
 /*
  * py_pjsua_config_default
+ * !modified @ 051206
  */
 static PyObject *py_pjsua_config_default(PyObject *pSelf, PyObject *pArgs)
@@ -1597,13 +1741,13 @@
     pjsua_config cfg;
 
-    if (!PyArg_ParseTuple(pArgs, "O", &obj))
+    if (!PyArg_ParseTuple(pArgs, ""))
     {
         return NULL;
     }
     pjsua_config_default(&cfg);
+	obj = (config_Object *) config_new(&config_Type, NULL, NULL);
     obj->max_calls = cfg.max_calls;
     obj->thread_cnt = cfg.thread_cnt;
-    Py_INCREF(Py_None);
-    return Py_None;
+    return (PyObject *)obj;
 }
 
@@ -1611,4 +1755,5 @@
 /*
  * py_pjsua_media_config_default
+ * !modified @ 051206
  */
 static PyObject * py_pjsua_media_config_default(PyObject *pSelf,
@@ -1617,9 +1762,10 @@
     media_config_Object *obj;
     pjsua_media_config cfg;
-    if (!PyArg_ParseTuple(pArgs, "O", &obj))
+    if (!PyArg_ParseTuple(pArgs, ""))
     {
         return NULL;
     }
     pjsua_media_config_default(&cfg);
+    obj = (media_config_Object *)PyType_GenericNew(&media_config_Type, NULL, NULL);
     obj->clock_rate = cfg.clock_rate;
     obj->ec_options = cfg.ec_options;
@@ -1634,6 +1780,5 @@
     obj->thread_cnt = cfg.thread_cnt;
     obj->tx_drop_pct = cfg.tx_drop_pct;
-    Py_INCREF(Py_None);
-    return Py_None;
+    return (PyObject *)obj;
 }
 
@@ -1641,4 +1786,5 @@
 /*
  * py_pjsua_msg_data_init
+ * !modified @ 051206
  */
 static PyObject *py_pjsua_msg_data_init(PyObject *pSelf, PyObject *pArgs)
@@ -1646,9 +1792,11 @@
     msg_data_Object *obj;
     pjsua_msg_data msg;
-    if (!PyArg_ParseTuple(pArgs, "O", &obj))
+    
+    if (!PyArg_ParseTuple(pArgs, ""))
     {
         return NULL;
     }
     pjsua_msg_data_init(&msg);
+    obj = (msg_data_Object *)msg_data_new(&msg_data_Type, NULL, NULL);
     Py_XDECREF(obj->content_type);
     obj->content_type = PyString_FromStringAndSize(
@@ -1659,135 +1807,8 @@
         msg.msg_body.ptr, msg.msg_body.slen
     );
-    obj->hdr_list = msg.hdr_list;
-    Py_INCREF(Py_None);
-    return Py_None;
-}
-
-
-/*
- * py_pjsua_logging_config_dup
- */
-static PyObject *py_pjsua_logging_config_dup(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_pool_Object *pool;
-    logging_config_Object *src;
-    logging_config_Object *dest;
-    pj_str_t strdest;
-    pj_str_t strsrc;
-    int len;
-
-    if (!PyArg_ParseTuple(pArgs, "OOO", &pool, &dest, &src))
-    {
-        return NULL;
-    }
-    pj_memcpy(dest, src, sizeof(*src));
-    len = strlen(PyString_AsString(src->log_filename));
-    strsrc.ptr = PyString_AsString(src->log_filename);
-    strsrc.slen = len;
-    pj_strdup_with_null(pool->pool, &strdest, &strsrc);
-    Py_XDECREF(dest->log_filename);
-    dest->log_filename = PyString_FromStringAndSize(strdest.ptr, strdest.slen);
-    Py_INCREF(Py_None);
-    return Py_None;
-}
-
-
-/*
- * py_pjsua_config_dup
- */
-static PyObject *py_pjsua_config_dup(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_pool_Object *pool;
-    config_Object *src;
-    config_Object *dest;
-    pj_str_t strdest;
-    pj_str_t strsrc;
-    int len;
-    unsigned i;
-
-    if (!PyArg_ParseTuple(pArgs, "OOO", &pool, &dest, &src))
-    {
-        return NULL;
-    }
-    pj_memcpy(dest, src, sizeof(*src));
-
-    for (i=0; i<src->outbound_proxy_cnt; ++i)
-    {
-        pj_strdup_with_null(
-            pool->pool, &dest->outbound_proxy[i], &src->outbound_proxy[i]
-        );
-    }
-
-    for (i=0; i<src->cred_count; ++i)
-    {
-        pjsip_cred_dup(pool->pool, &dest->cred_info[i], &src->cred_info[i]);
-    }
-    len = strlen(PyString_AsString(src->user_agent));
-    strsrc.ptr = PyString_AsString(src->user_agent);
-    strsrc.slen = len;
-    pj_strdup_with_null(pool->pool, &strdest, &strsrc);
-    Py_XDECREF(dest->user_agent);
-    dest->user_agent = PyString_FromStringAndSize(strdest.ptr, strdest.slen);
-    Py_INCREF(Py_None);
-    return Py_None;
-}
-
-
-/*
- * py_pjsip_cred_dup
- */
-static PyObject *py_pjsip_cred_dup(PyObject *pSelf, PyObject *pArgs)
-{
-    pj_pool_Object *pool;
-    pjsip_cred_info_Object *src;
-    pjsip_cred_info_Object *dest;
-	pjsip_cred_info s;
-	pjsip_cred_info d;
-    if (!PyArg_ParseTuple(pArgs, "OOO", &pool, &dest, &src))
-    {
-        return NULL;
-    }
-	s.data.ptr = PyString_AsString(src->data);
-	s.data.slen = strlen(PyString_AsString(src->data));
-	s.realm.ptr = PyString_AsString(src->realm);
-	s.realm.slen = strlen(PyString_AsString(src->realm));
-	s.scheme.ptr = PyString_AsString(src->scheme);
-	s.scheme.slen = strlen(PyString_AsString(src->scheme));
-	s.username.ptr = PyString_AsString(src->username);
-	s.username.slen = strlen(PyString_AsString(src->username));
-	s.data_type = src->data_type;
-	d.data.ptr = PyString_AsString(dest->data);
-	d.data.slen = strlen(PyString_AsString(dest->data));
-	d.realm.ptr = PyString_AsString(dest->realm);
-	d.realm.slen = strlen(PyString_AsString(dest->realm));
-	d.scheme.ptr = PyString_AsString(dest->scheme);
-	d.scheme.slen = strlen(PyString_AsString(dest->scheme));
-	d.username.ptr = PyString_AsString(dest->username);
-	d.username.slen = strlen(PyString_AsString(dest->username));
-	d.data_type = dest->data_type;
-    pjsip_cred_dup(pool->pool, &d, &s);
-	Py_XDECREF(src->data);
-	src->data = PyString_FromStringAndSize(s.data.ptr, s.data.slen);
-	Py_XDECREF(src->realm);
-	src->realm = PyString_FromStringAndSize(s.realm.ptr, s.realm.slen);
-	Py_XDECREF(src->scheme);
-	src->scheme = PyString_FromStringAndSize(s.scheme.ptr, s.scheme.slen);
-	Py_XDECREF(src->username);
-	src->username = 
-		PyString_FromStringAndSize(s.username.ptr, s.username.slen);
-    Py_INCREF(Py_None);
-	src->data_type = s.data_type;
-	Py_XDECREF(dest->data);
-	dest->data = PyString_FromStringAndSize(d.data.ptr, d.data.slen);
-	Py_XDECREF(dest->realm);
-	dest->realm = PyString_FromStringAndSize(d.realm.ptr, d.realm.slen);
-	Py_XDECREF(dest->scheme);
-	dest->scheme = PyString_FromStringAndSize(d.scheme.ptr, d.scheme.slen);
-	Py_XDECREF(dest->username);
-	dest->username = 
-		PyString_FromStringAndSize(d.username.ptr, d.username.slen);
-    Py_INCREF(Py_None);
-	src->data_type = s.data_type;
-    return Py_None;
+
+    translate_hdr_rev((pjsip_generic_string_hdr *)&msg.hdr_list, obj->hdr_list);
+    
+    return (PyObject *)obj;
 }
 
@@ -1922,4 +1943,5 @@
         return NULL;
     }
+	
     pjsua_perror(sender, title, status);
     Py_INCREF(Py_None);
@@ -1939,5 +1961,5 @@
     }
     status = pjsua_create();
-    printf("status %d\n",status);
+    //printf("status %d\n",status);
     return Py_BuildValue("i",status);
 }
@@ -2037,5 +2059,5 @@
     }
     status = pjsua_start();
-    printf("status %d\n",status);
+    //printf("status %d\n",status);
     return Py_BuildValue("i",status);
 }
@@ -2053,5 +2075,5 @@
     }
     status = pjsua_destroy();
-    printf("status %d\n",status);
+    //printf("status %d\n",status);
     return Py_BuildValue("i",status);
 }
@@ -2070,5 +2092,5 @@
     }
     ret = pjsua_handle_events(msec);
-    printf("return %d\n",ret);
+    //printf("return %d\n",ret);
     return Py_BuildValue("i",ret);
 }
@@ -2087,17 +2109,15 @@
     }
     status = pjsua_verify_sip_url(url);
-    printf("status %d\n",status);
+    //printf("status %d\n",status);
     return Py_BuildValue("i",status);
 }
 
 
-
-
-
-
-/*
- * error messages
- */
-
+/*
+ * function doc
+ */
+
+static char pjsua_thread_register_doc[] =
+    "int py_pjsua.thread_register(string name, int[] desc)";
 static char pjsua_perror_doc[] =
     "void py_pjsua.perror (string sender, string title, int status) "
@@ -2182,38 +2202,19 @@
 
 static char pjsua_logging_config_default_doc[] =
-    "void py_pjsua.logging_config_default  (py_pjsua.Logging_Config cfg)  "
+    "py_pjsua.Logging_Config py_pjsua.logging_config_default  ()  "
     "Use this function to initialize logging config.";
 
 static char pjsua_config_default_doc[] =
-    "void py_pjsua.config_default (py_pjsua.Config cfg). Use this function to "
-    "initialize pjsua config. Parameters: "
-        "cfg: pjsua config to be initialized.";
+    "py_pjsua.Config py_pjsua.config_default (). Use this function to "
+    "initialize pjsua config. ";
 
 static char pjsua_media_config_default_doc[] =
+    "py_pjsua.Media_Config py_pjsua.media_config_default (). "
     "Use this function to initialize media config.";
 
-static char pjsua_logging_config_dup_doc[] =
-    "void py_pjsua.logging_config_dup  (py_pjsua.PJ_Pool pool, "
-        "py_pjsua.Logging_Config dst, py_pjsua.Logging_Config src) "
-    "Use this function to duplicate logging config. Parameters: "
-        "pool: Pool to use;  "
-        "dst: Destination config;  "
-        "src: Source config.";
-
-static char pjsua_config_dup_doc[] =
-    "void py_pjsua.config_dup (py_pjsua.PJ_Pool pool, py_pjsua.Config dst, "
-                                "py_pjsua.Config src) "
-    "Duplicate pjsua_config. ";
-
-static char pjsip_cred_dup_doc[] =
-    "void py_pjsua.pjsip_cred_dup (py_pjsua.PJ_Pool pool, "
-                                "py_pjsua.PJSIP_Cred_Info dst, "
-                                "py_pjsua.PJSIP_Cred_Info src) "
-    "Duplicate credential.";
-
 static char pjsua_msg_data_init_doc[] =
-    "void py_pjsua.msg_data_init (py_pjsua.Msg_Data msg_data) "
-    "Initialize message data Parameters: "
-        "msg_data: Message data to be initialized.";
+    "py_pjsua.Msg_Data void py_pjsua.msg_data_init () "
+    "Initialize message data ";
+        
 
 /* END OF LIB BASE */
@@ -2229,5 +2230,5 @@
     PyObject_HEAD
     /* Type-specific fields go here. */
-	PyObject * stun_srv1;    
+    PyObject * stun_srv1;    
     unsigned stun_port1;
     PyObject * stun_srv2;
@@ -2283,23 +2284,23 @@
 {
     {
-    	"stun_port1", T_INT, offsetof(stun_config_Object, stun_port1), 0,
-    	"The first STUN server IP address or hostname."
-    },
-    {
-    	"stun_port2", T_INT, offsetof(stun_config_Object, stun_port2), 0,
-    	"Port number of the second STUN server. "
-		"If zero, default STUN port will be used."
+        "stun_port1", T_INT, offsetof(stun_config_Object, stun_port1), 0,
+        "The first STUN server IP address or hostname."
+    },
+    {
+        "stun_port2", T_INT, offsetof(stun_config_Object, stun_port2), 0,
+        "Port number of the second STUN server. "
+        "If zero, default STUN port will be used."
     },    
     {
-    	"stun_srv1", T_OBJECT_EX,
-    	offsetof(stun_config_Object, stun_srv1), 0,
-    	"The first STUN server IP address or hostname"
-    },
-    {
-    	"stun_srv2", T_OBJECT_EX,
-    	offsetof(stun_config_Object, stun_srv2), 0,
-    	"Optional second STUN server IP address or hostname, for which the "
-		"result of the mapping request will be compared to. If the value "
-		"is empty, only one STUN server will be used"
+        "stun_srv1", T_OBJECT_EX,
+        offsetof(stun_config_Object, stun_srv1), 0,
+        "The first STUN server IP address or hostname"
+    },
+    {
+        "stun_srv2", T_OBJECT_EX,
+        offsetof(stun_config_Object, stun_srv2), 0,
+        "Optional second STUN server IP address or hostname, for which the "
+        "result of the mapping request will be compared to. If the value "
+        "is empty, only one STUN server will be used"
     },
     {NULL}  /* Sentinel */
@@ -2365,9 +2366,9 @@
     PyObject_HEAD
     /* Type-specific fields go here. */
-	unsigned port;
-	PyObject * public_addr;
-	PyObject * bound_addr;
-	int use_stun;
-	stun_config_Object * stun_config;
+    unsigned port;
+    PyObject * public_addr;
+    PyObject * bound_addr;
+    int use_stun;
+    stun_config_Object * stun_config;
 } transport_config_Object;
 
@@ -2379,6 +2380,6 @@
 static void transport_config_dealloc(transport_config_Object* self)
 {
-	Py_XDECREF(self->public_addr);    
-	Py_XDECREF(self->bound_addr);    
+    Py_XDECREF(self->public_addr);    
+    Py_XDECREF(self->bound_addr);    
     Py_XDECREF(self->stun_config);    
     self->ob_type->tp_free((PyObject*)self);
@@ -2411,5 +2412,5 @@
         }
         self->stun_config = 
-			(stun_config_Object *)stun_config_new(&stun_config_Type,NULL,NULL);
+            (stun_config_Object *)stun_config_new(&stun_config_Type,NULL,NULL);
         if (self->stun_config == NULL)
     	{
@@ -2430,37 +2431,37 @@
 {
     {
-    	"port", T_INT, offsetof(transport_config_Object, port), 0,
-    	"UDP port number to bind locally. This setting MUST be specified "
-		"even when default port is desired. If the value is zero, the "
-		"transport will be bound to any available port, and application "
-		"can query the port by querying the transport info."
-    },
-    {
-    	"public_addr", T_OBJECT_EX, 
-		offsetof(transport_config_Object, public_addr), 0,
-    	"Optional address to advertise as the address of this transport. "
-		"Application can specify any address or hostname for this field, "
-		"for example it can point to one of the interface address in the "
-		"system, or it can point to the public address of a NAT router "
-		"where port mappings have been configured for the application."		
+        "port", T_INT, offsetof(transport_config_Object, port), 0,
+        "UDP port number to bind locally. This setting MUST be specified "
+        "even when default port is desired. If the value is zero, the "
+        "transport will be bound to any available port, and application "
+        "can query the port by querying the transport info."
+    },
+    {
+        "public_addr", T_OBJECT_EX, 
+	offsetof(transport_config_Object, public_addr), 0,
+        "Optional address to advertise as the address of this transport. "
+        "Application can specify any address or hostname for this field, "
+        "for example it can point to one of the interface address in the "
+        "system, or it can point to the public address of a NAT router "
+        "where port mappings have been configured for the application."		
     },    
-	{
-    	"bound_addr", T_OBJECT_EX, 
-		offsetof(transport_config_Object, bound_addr), 0,
-    	"Optional address where the socket should be bound to. This option "
-		"SHOULD only be used to selectively bind the socket to particular "
-		"interface (instead of 0.0.0.0), and SHOULD NOT be used to set the "
-		"published address of a transport (the public_addr field should be "
-		"used for that purpose)."		
+    {
+        "bound_addr", T_OBJECT_EX, 
+        offsetof(transport_config_Object, bound_addr), 0,
+        "Optional address where the socket should be bound to. This option "
+        "SHOULD only be used to selectively bind the socket to particular "
+        "interface (instead of 0.0.0.0), and SHOULD NOT be used to set the "
+        "published address of a transport (the public_addr field should be "
+        "used for that purpose)."		
     },    
     {
-    	"use_stun", T_INT,
-    	offsetof(transport_config_Object, use_stun), 0,
-    	"Flag to indicate whether STUN should be used."
-    },
-    {
-    	"stun_config", T_OBJECT_EX,
-    	offsetof(transport_config_Object, stun_config), 0,
-    	"STUN configuration, must be specified when STUN is used."
+        "use_stun", T_INT,
+        offsetof(transport_config_Object, use_stun), 0,
+        "Flag to indicate whether STUN should be used."
+    },
+    {
+        "stun_config", T_OBJECT_EX,
+        offsetof(transport_config_Object, stun_config), 0,
+        "STUN configuration, must be specified when STUN is used."
     },
     {NULL}  /* Sentinel */
@@ -2594,7 +2595,7 @@
 #endif
     {
-    	"sa_data", T_OBJECT_EX,
-    	offsetof(sockaddr_Object, sa_data), 0,
-    	"Address data"
+        "sa_data", T_OBJECT_EX,
+        offsetof(sockaddr_Object, sa_data), 0,
+        "Address data"
     },
     {NULL}  /* Sentinel */
@@ -2708,7 +2709,7 @@
     },
     {
-    	"host", T_OBJECT_EX,
-    	offsetof(host_port_Object, host), 0,
-    	"Host part or IP address."
+        "host", T_OBJECT_EX,
+        offsetof(host_port_Object, host), 0,
+        "Host part or IP address."
     },
     {NULL}  /* Sentinel */
@@ -2762,7 +2763,10 @@
 };
 
-/*
- * transport_id_Object
- * C/Python wrapper for transport_id object
+
+
+
+/*
+ * transport_info_Object
+ * Transport info
  */
 typedef struct
@@ -2770,143 +2774,13 @@
     PyObject_HEAD
     /* Type-specific fields go here. */
-    int transport_id;
-} transport_id_Object;
-
-
-/*
- * transport_id_members
- * declares attributes accessible from 
- * both C and Python for transport_id object
- */
-static PyMemberDef transport_id_members[] =
-{
-    {
-        "transport_id", T_INT, offsetof(transport_id_Object, transport_id), 0,
-        "SIP transport identification"
-    },
-    {NULL}  /* Sentinel */
-};
-
-
-/*
- * transport_id_Type
- */
-static PyTypeObject transport_id_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Transport_ID",        /*tp_name*/
-    sizeof(transport_id_Object),    /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    0,                              /*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Transport ID objects",         /*tp_doc*/
-    0,                              /*tp_traverse*/
-    0,                              /*tp_clear*/
-    0,                              /*tp_richcompare*/
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    transport_id_members,           /* tp_members */
-
-};
-
-/*
- * integer_Object
- * C/Python wrapper for integer object
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    int integer;
-} integer_Object;
-
-
-/*
- * integer_members
- * declares attributes accessible from both C and Python for integer object
- */
-static PyMemberDef integer_members[] =
-{
-    {
-        "integer", T_INT, offsetof(integer_Object, integer), 0,
-        "integer value"
-    },
-    {NULL}  /* Sentinel */
-};
-
-
-/*
- * integer_Type
- */
-static PyTypeObject integer_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Integer",        /*tp_name*/
-    sizeof(integer_Object),    /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    0,                              /*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Integer objects",         /*tp_doc*/
-    0,                              /*tp_traverse*/
-    0,                              /*tp_clear*/
-    0,                              /*tp_richcompare*/
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0,                              /* tp_methods */
-    integer_members,           /* tp_members */
-
-};
-
-
-/*
- * transport_info_Object
- * Transport info
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-	int id;
-	int type;
-	PyObject * type_name;
-	PyObject * info;
-	unsigned flag;
-	unsigned addr_len;
-	sockaddr_Object * local_addr;
-	host_port_Object * local_name;
-	unsigned usage_count;
+    int id;
+    int type;
+    PyObject * type_name;
+    PyObject * info;
+    unsigned flag;
+    unsigned addr_len;
+    sockaddr_Object * local_addr;
+    host_port_Object * local_name;
+    unsigned usage_count;
 } transport_info_Object;
 
@@ -2919,7 +2793,7 @@
 {
     Py_XDECREF(self->type_name); 
-	Py_XDECREF(self->info);
-	Py_XDECREF(self->local_addr);
-	Py_XDECREF(self->local_name);
+    Py_XDECREF(self->info);
+    Py_XDECREF(self->local_addr);
+    Py_XDECREF(self->local_name);
     self->ob_type->tp_free((PyObject*)self);
 }
@@ -2938,5 +2812,5 @@
     if (self != NULL)
     {
-		self->type_name = PyString_FromString("");
+        self->type_name = PyString_FromString("");
         if (self->type_name == NULL)
     	{
